-- buBipedFinger Ver.1.1
-- ؘaG kasiwagi@ummb.jp
-- Biped̎w𑀍삷c[łBBiped̉Ẽp[cIĂƉE̎wA
-- ȊOƍ̎w𑀍ł܂BXC_[ł܂āAẼ{^őIĔAȊB
-- ԉ̃XC_[͎w̍L𒲐Bcopy͎w̃|[ỸRs[Breset̓ZbgłB
-- 
-- 1.1 Cӂ̎w̑gݍ킹ɑΉĂ݂BƂWŃRNVȂԂł̓Rs[oȂB
--     w̋Ȃƃ}VɂĂ݂B
-- 1.0 ŏ̃o[W

macroScript buBipedFinger
	category:"Bu"
	buttontext:"buBipedFinger"
	toolTip:"buBipedFinger"
(
	local withHand = true

	fn getLocal n = return (n.transform*inverse(n.parent.transform)).rotation as eulerangles

	-- ew̋ȂBPȐ`ϊȂ̂ŁAƋÂ肽ꍇ̓JX^Agr[gł
	-- oRăANV}l[W[Őݒ肵Ă悢B
	fn fAngle n v =
	(
		case n of
		(
			-- lw珬w܂ł̋Ȃ
			1: case of
				(
					(v<0.0): return v
					(v>=0.0 and v<50.0): return (v*3/5)
					(v>=50.0): return (v-20)
				)
			2: case of
				(
					(v<0.0): return 0
					(v>=0.0 and v<50.0): return (v*2)
					(v>=0.0): return 100
				)
			3: case of
				(
					(v<0.0): return 0
					(v>=0.0 and v<50.0): return (v*8/5)
					(v>=0.0): return 80
				)
			-- ew̋Ȃ
			4: case of -- link==1 ̎̂
				(
					(v<0.0): return v
					(v>=0.0 and v<50.0): return (v/5)
					(v>=50.0): return (v*7/5-60)
				)
			5: case of
				(
					(v<0.0): return v/2
					(v>=0.0 and v<50.0): return (v/5)
					(v>=50.0): return (v*7/10-25)
				)
			6: case of
				(
					(v<0.0): return 0
					(v>=0.0 and v<60.0): return (v*9/6)
					(v>=60.0): return 90
				)
		)
	)

	-- w̍L
	fn fSPD n v =
	(
		case n of
		(
			1: case of
				(
					(v<0.0): return -v/4
					(v>=0.0): return (-v*3/10)
				)
			
			2: case of
				(
					(v<0.0): return -v/4
					(v>=0.0): return (-v/4)
				)
			3: case of
				(
					(v<0.0): return v/8
					(v>=0.0): return (v/20)
				)
			4: case of
				(
					(v<0.0): return v/4
					(v>=0.0): return (v*17/100)
				)
			5: case of
				(
					(v<0.0): return v/2
					(v>=0.0): return (v*2/5)
				)
		)
	)

	-- lw珬w܂
	fn rotFingerA n val =
	(
		local lr = true
		local targetBip = selection[1]
		if Biped_Object != classof targetBip do return()
		local s = (targetBip.controller as string)[12]
		if "R" == s do lr = false

		local ln = (targetBip.controller.rootNode).controller.fingerlinks

		for i = 1 to ln do
			try
			(
				if lr then
					node = biped.getNode targetBip #lfingers link:(n*ln+i)
				else
					node = biped.getNode targetBip #rfingers link:(n*ln+i)

				in coordsys node
				(
					r = fAngle i val
					f1 = getLocal node
					r -= f1.z
					rotate node (angleaxis r [0,0,1])
				)
			) catch()
	)


	-- ew
	fn rotFingerB val =
	(
		local lr = true
		local targetBip = selection[1]
		if Biped_Object != classof targetBip do return()
		local s = (targetBip.controller as string)[12]
		if "R" == s do lr = false

		local ln = (targetBip.controller.rootNode).controller.fingerlinks

		-- linkP̎͐ew̍Ȃ
		for i = (if 1 == ln then 1 else 2) to ln do
			try
			(
				if lr then
					node = biped.getNode targetBip #lfingers link:i
				else
					node = biped.getNode targetBip #rfingers link:i

				in coordsys node
				(
					r = fAngle (i+3) val
					f1 = getLocal node
					r -= f1.z
					rotate node (angleaxis r [0,0,1])
				)
			) catch()
	)

	-- L
	fn rotFingerC val =
	(
		local lr = true
		local targetBip = selection[1]
		if Biped_Object != classof targetBip do return()
		local s = (targetBip.controller as string)[12]
		if "R" == s do lr = false

		local fTbl = #(#(3),#(1,3),#(1,2,4),#(1,2,3,4),#(1,2,3,4,5)) -- gݍ킹̃e[u
		local ln = (targetBip.controller.rootNode).controller.fingerlinks
		local fgn = (targetBip.controller.rootNode).controller.fingers

		for i=1 to fgn do
		(
			try
			(
				if lr then
					node = biped.getNode targetBip #lfingers link:(ln*(i-1)+1)
				else
					node = biped.getNode targetBip #rfingers link:(ln*(i-1)+1)

				in coordsys node
				(
					r = fSPD fTbl[fgn][i] val
					if lr then r *= -1
					f1 = getLocal node
					r -= f1.y
					rotate node (angleaxis r [0,1,0])
				)
			) catch()
		)
	)

	-- Rs[
	fn copyHand =
	(
		local handAr = #(),node
		local lr = true
		local targetBip = selection[1]
		if Biped_Object != classof targetBip do return()
		local s = (targetBip.controller as string)[12]
		if "R" == s do lr = false

		for i = 1 to 15 do
		(
			if lr then
				node = biped.getNode targetBip #lfingers link:i
			else
				node = biped.getNode targetBip #rfingers link:i
		
			if undefined != node do append handAr node
		)
		if withHand do
		(
			if lr then
				node = biped.getNode targetBip #lArm link:4
			else
				node = biped.getNode targetBip #rArm link:4
			if undefined != node do append handAr node
		)
		local s = for i in selection collect i
		with redraw off
		(
			suspendEditing()
			select handAr
			try biped.copyPosture handAr[1].controller #posture false false false catch()
			select s
			resumeEditing()
		)
	)

	fn selFinger f n =
	(
		local handAr = #(),node
		local lr = true
		local targetBip = selection[1]
		if Biped_Object != classof targetBip do return()
		local s = (targetBip.controller as string)[12]
		if "R" == s do lr = false

		local ln = (targetBip.controller.rootNode).controller.fingerlinks

		if ln < n do return()
		if 5 == f then
		(
			for i = ln to 12 by ln do
			(
				if lr then
					node = biped.getNode targetBip #lfingers link:(i+n)
				else
					node = biped.getNode targetBip #rfingers link:(i+n)
				if undefined != node do append handAr node
			)
			with redraw off try select handAr catch()
		) else (
			with redraw off
			(
				try
				(
					if lr then
						select (biped.getNode targetBip #lfingers link:(f*ln+n))
					else
						select (biped.getNode targetBip #rfingers link:(f*ln+n))
				) catch()
			)
		)
	)

	rollout buBipedFingerRoll "buBipedFinger" width:188
	(
		-- UI
		-- ew
		button btn01 "th" pos:[ 124,6] width:20
		on btn01 pressed do selFinger 0 1
		button btn02 "um" pos:[ 144,6] width:20
		on btn02 pressed do selFinger 0 2
		button btn03 "b " pos:[ 164,6] width:20
		on btn03 pressed do selFinger 0 3

		slider F0Z ticks:0 range:[-20,100,0] pos:[ 8,4] width:120
		on F0Z changed val do
		(
			local targetBip = selection[1]
			if Biped_Object != classof targetBip do return()
			if 1 == (targetBip.controller.rootNode).controller.fingers then
				rotFingerA 0 val
			else
				rotFingerB val
		)

		-- lw
		button btn11 "in" pos:[ 124,36] width:20
		on btn11 pressed do selFinger 1 1
		button btn12 "de" pos:[ 144,36] width:20
		on btn12 pressed do selFinger 1 2
		button btn13 "x " pos:[ 164,36] width:20
		on btn13 pressed do selFinger 1 3

		slider F1Z ticks:0 range:[-20,100,0] pos:[ 8,34] width:120
		on F1Z changed val do rotFingerA 1 val

		-- w
		button btn21 "mi" pos:[ 124,66] width:20
		on btn21 pressed do selFinger 2 1
		button btn22 "dd" pos:[ 144,66] width:20
		on btn22 pressed do selFinger 2 2
		button btn23 "le" pos:[ 164,66] width:20
		on btn23 pressed do selFinger 2 3

		slider F2Z ticks:0 range:[-20,100,0] pos:[ 8,64] width:120
		on F2Z changed val do rotFingerA 2 val

		-- w
		button btn31 "ri" pos:[ 124,96] width:20
		on btn31 pressed do selFinger 3 1
		button btn32 "ng" pos:[ 144,96] width:20
		on btn32 pressed do selFinger 3 2
		button btn33 pos:[ 164,96] width:20
		on btn33 pressed do selFinger 3 3

		slider F3Z ticks:0 range:[-20,100,0] pos:[ 8,94] width:120
		on F3Z changed val do rotFingerA 3 val

		-- w
		button btn41 "li" pos:[ 124,126] width:20
		on btn41 pressed do selFinger 4 1
		button btn42 "tt" pos:[ 144,126] width:20
		on btn42 pressed do selFinger 4 2
		button btn43 "le" pos:[ 164,126] width:20
		on btn43 pressed do selFinger 4 3

		slider F4Z ticks:0 range:[-20,100,0] pos:[ 8,124] width:120
		on F4Z changed val do rotFingerA 4 val

		-- L
		button btn51 "sp" pos:[ 124,156] width:20
		on btn51 pressed do selFinger 5 1
		button btn52 "re" pos:[ 144,156] width:20
		on btn52 pressed do selFinger 5 2
		button btn53 "ad" pos:[ 164,156] width:20
		on btn53 pressed do selFinger 5 3

		slider FSPD ticks:0 range:[-20,100,0] pos:[ 8,154] width:120
		on FSPD changed val do rotFingerC val

		-- ̑
		button btnCopy "copy" pos:[ 4,186] width:40
		on btnCopy pressed do copyHand()

		checkbox ckWH "withHand" checked:true pos:[ 50,190]
		on ckWH changed s do withHand = s

		button btnReset "reset" pos:[ 144,186] width:40
		on btnReset pressed do
		(
			F0Z.value = F1Z.value = F2Z.value = F3Z.value = F4Z.value = FSPD.value = 0
			local targetBip = selection[1]
			if Biped_Object != classof targetBip do return()
			if 1 != (targetBip.controller.rootNode).controller.fingers then
				rotFingerB 0
			else
				rotFingerA 0 0

			rotFingerA 1 0
			rotFingerA 2 0
			rotFingerA 3 0
			rotFingerA 4 0
			rotFingerC 0
		)
	)
	
	global buBipedFingerPos = [200,100]
	on isChecked do buBipedFingerRoll.open
	on execute do createDialog buBipedFingerRoll pos:buBipedFingerPos
	on closeDialogs do
	(
		buBipedFingerPos = GetDialogPos buBipedFingerRoll
		destroyDialog buBipedFingerRoll
	)
)
